from struct import pack
from hashlib import sha1
from Crypto.Util import strxor

hash_func = sha1
hash_len = hash_func().digestsize

def mgf1(seed, masklen):    
    if masklen > (1 << 32) * hash_len:
        raise ValueError("mask too long")

    t = ""
    end = masklen / hash_len + 1
    for counter in xrange(end + 1):
        c = pack(">I", counter)
        t += hash_func(seed + c).digest()
    return t[:masklen]

def oaep_decode(em, seed_len):
    y, maskedSeed, maskedDB = em[0], em[1:1+seed_len], em[1+seed_len:]
    seedMask = mgf1(maskedDB, seed_len)
    seed = strxor.strxor(maskedSeed, seedMask)
    DBMask = mgf1(seed, len(maskedDB))
    DB = strxor.strxor(maskedDB, DBMask)
    return DB, seed